Bug 994832 - [abrt] alsa-utils-1.0.27.2-2.fc19: _IO_vfprintf_internal: Process /usr/sbin/alsactl was killed by signal 11 (SIGSEGV)
[abrt] alsa-utils-1.0.27.2-2.fc19: _IO_vfprintf_internal: Process /usr/sbin/a...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: alsa-utils (Show other bugs)
19
x86_64 Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jaroslav Kysela
Fedora Extras Quality Assurance
abrt_hash:a07ba771e16fa58bb6a9078b2dc...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-08 01:44 EDT by David Strauss
Modified: 2014-01-28 22:05 EST (History)
13 users (show)

See Also:
Fixed In Version: alsa-utils-1.0.27.2-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1056955 (view as bug list)
Environment:
Last Closed: 2014-01-28 22:05:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
File: backtrace (254.93 KB, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: cgroup (166 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: core_backtrace (2.51 KB, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: dso_list (644 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: environ (115 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: exploitable (82 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: limits (1.29 KB, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: maps (3.55 KB, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: open_fds (300 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: proc_pid_status (889 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
File: var_log_messages (777 bytes, text/plain)
2013-08-08 01:44 EDT, David Strauss
no flags Details
alsa-info.sh output (25.32 KB, text/plain)
2013-12-06 13:50 EST, Rex Dieter
no flags Details
asound.state as requested (4.28 KB, text/plain)
2013-12-06 13:51 EST, Rex Dieter
no flags Details
Proposed patch (727 bytes, patch)
2013-12-27 20:56 EST, Alan Hamilton
no flags Details | Diff

  None (edit)
Description David Strauss 2013-08-08 01:44:25 EDT
Version-Release number of selected component:
alsa-utils-1.0.27.2-2.fc19

Additional info:
reporter:       libreport-2.1.6
backtrace_rating: 4
cmdline:        /usr/sbin/alsactl -s -n 19 -c -E ALSA_CONFIG_PATH=/etc/alsa/alsactl.conf --initfile=/lib/alsa/init/00main rdaemon
crash_function: _IO_vfprintf_internal
executable:     /usr/sbin/alsactl
kernel:         3.10.4-300.fc19.x86_64
runlevel:       unknown
uid:            0

Truncated backtrace:
Thread no. 1 (8 frames)
 #0 _IO_vfprintf_internal at vfprintf.c:1635
 #1 ___vsnprintf_chk at vsnprintf_chk.c:63
 #2 vsnprintf at /usr/include/bits/stdio2.h:77
 #3 syslog_ at utils.c:112
 #4 cerror_ at utils.c:154
 #5 set_control at state.c:1325
 #6 set_controls at state.c:1512
 #7 load_state at state.c:1746
Comment 1 David Strauss 2013-08-08 01:44:28 EDT
Created attachment 784221 [details]
File: backtrace
Comment 2 David Strauss 2013-08-08 01:44:30 EDT
Created attachment 784222 [details]
File: cgroup
Comment 3 David Strauss 2013-08-08 01:44:32 EDT
Created attachment 784223 [details]
File: core_backtrace
Comment 4 David Strauss 2013-08-08 01:44:34 EDT
Created attachment 784224 [details]
File: dso_list
Comment 5 David Strauss 2013-08-08 01:44:36 EDT
Created attachment 784225 [details]
File: environ
Comment 6 David Strauss 2013-08-08 01:44:40 EDT
Created attachment 784226 [details]
File: exploitable
Comment 7 David Strauss 2013-08-08 01:44:43 EDT
Created attachment 784227 [details]
File: limits
Comment 8 David Strauss 2013-08-08 01:44:46 EDT
Created attachment 784228 [details]
File: maps
Comment 9 David Strauss 2013-08-08 01:44:48 EDT
Created attachment 784229 [details]
File: open_fds
Comment 10 David Strauss 2013-08-08 01:44:50 EDT
Created attachment 784230 [details]
File: proc_pid_status
Comment 11 David Strauss 2013-08-08 01:44:52 EDT
Created attachment 784231 [details]
File: var_log_messages
Comment 12 Raymond 2013-09-20 21:07:13 EDT
\070", '\000' <repeats 43 times>, "`\301\326\037\377\177\000\000P\301\326\037\377\177\000\000n\306+\312\070\000\000\000"...
#4  0x000000000040b2b7 in cerror_ (fcn=fcn@entry=0x412708 <__FUNCTION__.9591> "set_control", line=line@entry=1325, cond=<optimized out>, fmt=fmt@entry=0x412860 "failed to obtain info for control #%d (%s)") at utils.c:154
        ap = {{gp_offset = 16, fp_offset = 0, overflow_arg_area = 0x0, reg_save_area = 0x3f5df7a6c0}}
#5  0x00000000004098d1 in set_control (handle=0x98d550, control=0x982140, maxnumid=maxnumid@entry=0x7fff1fd6c83c, doit=doit@entry=1) at state.c:1325
        ctl = 0x7fff1fd6c0e0
        info = 0x7fff1fd6bfc0
        i = <optimized out>
        next = 0x9821f8
        numid1 = <optimized out>
        iface = SND_CTL_ELEM_IFACE_MIXER
        iface1 = <optimized out>
        name1 = <optimized out>
        numid = 3
        type = <optimized out>
        count = <optimized out>
        device = 0
        device1 = <optimized out>
        subdevice = 0
        subdevice1 = <optimized out>
        name = 0x982240 "Analog Mic Boost Capture Enum"
        index1 = <optimized out>
        index = 0
        value = 0x982300
        comment = 0x982370
        idx = <optimized out>
        err = -2
        set = <optimized out>
        id = 0x9820d0 "3"
        __FUNCTION__ = "set_control"


post the output of alsa-info.sh and  asound.state
Comment 13 Rex Dieter 2013-12-06 13:50:41 EST
Created attachment 833703 [details]
alsa-info.sh output
Comment 14 Rex Dieter 2013-12-06 13:51:46 EST
Created attachment 833714 [details]
asound.state as requested
Comment 15 Branko Grubić 2013-12-16 19:29:33 EST
I maybe commented on a wrong bug ( bug #1018513 ), but saw a segfault of alsactl in dmesg, and found same version of alsa-utils (but probably different problem), later tried to play with systemctl start/stop/restart alsa-{store,restore,state}.service and state triggered this crash, it was shown in abrt, and when I tried to report it:

--- Running report_uReport ---
This problem has already been reported.
https://retrace.fedoraproject.org/faf/reports/155999/
https://bugzilla.redhat.com/show_bug.cgi?id=994832


3.12.5-301.fc20.x86_64
alsa-utils-1.0.27.2-3.fc20.x86_64


[   32.782439] alsactl[695]: segfault at 76 ip 00007f53f8c87d76 sp 00007fff4b77a120 error 4 in libc-2.18.so[7f53f8c3f000+1b4000]
[24244.921302] alsactl[10457]: segfault at 76 ip 00007fd93915ed76 sp 00007fff68ced480 error 4 in libc-2.18.so[7fd939116000+1b4000]
Comment 16 Raymond 2013-12-20 22:22:13 EST
 rdaemon   <card>  like daemon but do the state restore at first


I guess this occur after you update the alsa-driver changes the controls name

the control saved by the old driver "Analog Mic Boost Capture Enum" when boot with alsactl rdaemon 

the new driver use  'Internal Mic Boost Volume'
Comment 17 H.J. Lu 2013-12-22 10:22:12 EST
Also happened to me on Fedora 20 upgrade from Fedora 17.
Many names are changed.
Comment 18 Alan Hamilton 2013-12-27 20:39:52 EST
The crash is caused by cerror_() in utils.c calling syslog_() without initializing the va_list ap. This uninitialized arg list is passed to vsnprintf() which causes the crash.

The va_start(ap, fmt) needs to be moved outside the if block, like it is in the error_() function. This bug is also in the dbg_() function.

This will at least prevent the crash, though not the error it's trying to log.
Comment 19 Alan Hamilton 2013-12-27 20:56:19 EST
Created attachment 842552 [details]
Proposed patch
Comment 20 Jaroslav Kysela 2013-12-29 14:08:21 EST
Thanks, I commited your patch to upstream and I will prepare the Fedora fix ASAP.

http://git.alsa-project.org/?p=alsa-utils.git;a=commitdiff;h=f4be3f88b6e80e3f3ea19ba5784cff49ab6e6277
Comment 21 Fedora Update System 2014-01-06 10:51:16 EST
alsa-utils-1.0.27.2-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/alsa-utils-1.0.27.2-3.fc19
Comment 22 Fedora Update System 2014-01-06 11:02:29 EST
alsa-utils-1.0.27.2-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/alsa-utils-1.0.27.2-4.fc20
Comment 23 Fedora Update System 2014-01-07 04:50:52 EST
Package alsa-utils-1.0.27.2-3.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing alsa-utils-1.0.27.2-3.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-0359/alsa-utils-1.0.27.2-3.fc19
then log in and leave karma (feedback).
Comment 24 Fedora Update System 2014-01-09 02:40:17 EST
alsa-utils-1.0.27.2-4.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 Fedora Update System 2014-01-28 22:05:18 EST
alsa-utils-1.0.27.2-3.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.